Operacja uruchomienia raportu jest wykonywana asynchronicznie jako długotrwała operacja,
reprezentowana przez
Operation
obiekt. Wynikiem operacji uruchomienia raportu są wyniki raportu oparte na
Report
obiekcie.
Z tego przewodnika dowiesz się, jak używać Curation Partners API, aby uzyskać operację uruchomienia raportu, sprawdzić stan operacji, i pobrać wyniki ukończonej operacji uruchomienia raportu.
Zanim zaczniesz
Zanim przejdziesz dalej, musisz wykonać te czynności:
- Skonfiguruj uwierzytelnianie.
- Uruchom raport aby uzyskać nazwę zasobu długotrwałej operacji.
Sprawdzanie stanu uruchomienia raportu
Aby sprawdzić stan wykonania operacji uruchomienia raportu, użyj
curators.reports.operations.get
metody.
Ten przykład wysyła żądanie GET w celu sprawdzenia stanu operacji:
REST
Żądanie
curl \
'https://curationpartners.googleapis.com/v1/curators/ACCOUNT_ID/reports/123456789/operations/10486370264' \
--header 'Authorization: Bearer ACCESS_TOKEN' \
--header 'Accept: application/json' \
--compressed
Zastąp te elementy:
ACCOUNT_ID: identyfikator konta.ACCESS_TOKEN: token dostępu.
Odpowiedź
Po pomyślnym zakończeniu operacji odpowiedź jest obiektem Operation z polem done ustawionym na true, a ładunek response jest wypełniony nazwą zasobu reportResult:
{
"name": "curators/ACCOUNT_ID/reports/123456789/operations/10486370264",
"done": true,
"metadata": {
"@type": "type.googleapis.com/google.ads.curationpartners.v1.RunReportMetadata",
"percentComplete": 100
},
"response": {
"@type": "type.googleapis.com/google.ads.curationpartners.v1.RunReportResponse",
"reportResult": "curators/ACCOUNT_ID/reports/123456789/results/10486370264"
}
}
Java
/* * Copyright (c) 2026 Google LLC * * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except * in compliance with the License. You may obtain a copy of the License at * * http://www.apache.org/licenses/LICENSE-2.0 * * Unless required by applicable law or agreed to in writing, software distributed under the License * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express * or implied. See the License for the specific language governing permissions and limitations under * the License. */ package com.google.api.services.samples.curationpartners.v1.curators.reports.operations; import com.google.api.services.curationpartners.v1.CurationPartners; import com.google.api.services.curationpartners.v1.model.Operation; import com.google.api.services.samples.curationpartners.v1.Utils; import java.io.IOException; import java.security.GeneralSecurityException; import net.sourceforge.argparse4j.ArgumentParsers; import net.sourceforge.argparse4j.inf.ArgumentParser; import net.sourceforge.argparse4j.inf.ArgumentParserException; import net.sourceforge.argparse4j.inf.Namespace; public class GetReportOperation { /** * Executes the get operation for a report operation. * * @param curationPartnersClient the initialized Curation Partners API client. * @param accountId the account ID of the curator. * @param reportId the resource ID of the report. * @param operationId the resource ID of the report operation. * @throws IOException if the API returns an error. */ public static void execute( CurationPartners curationPartnersClient, Long accountId, String reportId, String operationId) throws IOException { String name = String.format( "curators/%s/reports/%s/operations/%s", accountId, reportId, operationId); System.out.printf("Getting report operation with name \"%s\".%n", name); // Get the status of the report operation. Operation operation = curationPartnersClient .curators() .reports() .operations() .get(name) .execute(); System.out.println("Successfully retrieved report operation:"); Utils.jsonPrettyPrint(operation); } /** * Creates and configures the ArgumentParser for this sample. * * @return the configured ArgumentParser. */ private static ArgumentParser createArgumentParser() { ArgumentParser parser = ArgumentParsers.newFor("GetReportOperation") .build() .defaultHelp(true) .description("Gets the status of a long-running report operation. If the " + "operation is done, you can view the report contents with the " + "`curators.reports.results.fetchRows` method."); // Required arguments. parser .addArgument("-a", "--account_id") .help("The account ID of the curator.") .required(true) .type(Long.class); parser .addArgument("-r", "--report_id") .help("The resource ID of the report.") .required(true); parser .addArgument("-o", "--operation_id") .help("The resource ID of the report operation to retrieve.") .required(true); return parser; } public static void main(String[] args) { ArgumentParser parser = createArgumentParser(); Namespace parsedArgs = null; try { parsedArgs = parser.parseArgs(args); } catch (ArgumentParserException ex) { parser.handleError(ex); System.exit(1); } CurationPartners client = null; try { client = Utils.getCurationPartnersClient(); } catch (IOException ex) { System.out.printf("Unable to create Curation Partners API service:%n%s", ex); System.out.println("Did you specify a valid path to a service account key file?"); System.exit(1); } catch (GeneralSecurityException ex) { System.out.printf("Unable to establish secure HttpTransport:%n%s", ex); System.exit(1); } try { execute( client, parsedArgs.getLong("account_id"), parsedArgs.getString("report_id"), parsedArgs.getString("operation_id")); } catch (IOException ex) { System.out.printf("Curation Partners API returned error response:%n%s", ex); System.exit(1); } } }
Poniżej opisujemy, jak używać pola done do sprawdzania stanu operacji:
- Jeśli pole
donew odpowiedzi ma wartośćfalse, operacja uruchomienia raportu jest nadal przetwarzana. - Jeśli pole
donew odpowiedzi ma wartośćtrue, operacja uruchomienia raportu została zakończona. ObiektOperationw treści odpowiedzi zawiera też jedno z tych pól:response: wskazuje, że operacja uruchomienia raportu zakończyła się pomyślnie. To pole jest obiektem wypełnionym polem@typeustawionym na typtype.googleapis.com/google.ads.curationpartners.v1.RunReportResponse. TypRunReportResponsejest wypełniony polemreportResultzawierającym nazwę odpowiedniego raporturesult.error: wskazuje, że operacja uruchomienia raportu nie powiodła się. Poleerrorjest wypełnione obiektemStatusopisującym przyczynę niepowodzenia uruchomienia raportu.
Pobieranie wierszy z ukończonego raportu
Zawartość ukończonej operacji uruchomienia raportu możesz pobrać za pomocą metody
curators.reports.results.fetchRows. Musisz wypełnić parametr ścieżki name dla wyniku raportu, czyli nazwę zasobu z pola reportResult ukończonej operacji uruchomienia raportu.
Ten przykład wysyła żądanie GET w celu pobrania wierszy wyników:
REST
Żądanie
curl \
'https://curationpartners.googleapis.com/v1/curators/ACCOUNT_ID/reports/123456789/results/10486370264:fetchRows?pageSize=1' \
--header 'Authorization: Bearer ACCESS_TOKEN' \
--header 'Accept: application/json' \
--compressed
Odpowiedź
{
"rows": [
{
"dimensionValues": [
{
"stringValue": "2026-08-01"
},
{
"stringValue": "segment-1001"
}
],
"metricValueGroups": [
{
"primaryValues": [
{
"intValue": "150000"
},
{
"intValue": "3200"
},
{
"doubleValue": 450.75
},
{
"doubleValue": 45.08
}
]
}
]
}
],
"runTime": "2026-08-05T12:00:00Z",
"dateRanges": [
{
"startDate": {
"year": 2026,
"month": 7,
"day": 6
},
"endDate": {
"year": 2026,
"month": 8,
"day": 4
}
}
],
"totalRowCount": 2,
"nextPageToken": "QC7nzW91c2VTcGFubmVyQ29udGlubWF0aW6uVG9wZY45NP=="
}
Java
/* * Copyright (c) 2026 Google LLC * * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except * in compliance with the License. You may obtain a copy of the License at * * http://www.apache.org/licenses/LICENSE-2.0 * * Unless required by applicable law or agreed to in writing, software distributed under the License * is distributed on an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express * or implied. See the License for the specific language governing permissions and limitations under * the License. */ package com.google.api.services.samples.curationpartners.v1.curators.reports.results; import com.google.api.services.curationpartners.v1.CurationPartners; import com.google.api.services.curationpartners.v1.model.FetchReportResultRowsResponse; import com.google.api.services.samples.curationpartners.v1.Utils; import java.io.IOException; import java.security.GeneralSecurityException; import net.sourceforge.argparse4j.ArgumentParsers; import net.sourceforge.argparse4j.inf.ArgumentParser; import net.sourceforge.argparse4j.inf.ArgumentParserException; import net.sourceforge.argparse4j.inf.Namespace; public class FetchReportResultRows { /** * Executes the fetchRows operation for report result rows. * * @param curationPartnersClient the initialized Curation Partners API client. * @param accountId the account ID of the curator. * @param reportId the resource ID of the report. * @param resultId the resource ID of the report result. * @param pageSize the maximum number of rows to return per page. * @param pageToken the page token from a previous response, if any. * @throws IOException if the API returns an error. */ public static void execute( CurationPartners curationPartnersClient, Long accountId, String reportId, String resultId, Integer pageSize, String pageToken) throws IOException { String name = String.format("curators/%s/reports/%s/results/%s", accountId, reportId, resultId); System.out.printf("Fetching report result rows for \"%s\".%n", name); CurationPartners.Curators.Reports.Results.FetchRows request = curationPartnersClient.curators().reports().results().fetchRows(name); if (pageSize != null) { request.setPageSize(pageSize); } if (pageToken != null) { request.setPageToken(pageToken); } FetchReportResultRowsResponse response = request.execute(); System.out.println("Successfully fetched report result rows:"); Utils.jsonPrettyPrint(response); } /** * Creates and configures the ArgumentParser for this sample. * * @return the configured ArgumentParser. */ private static ArgumentParser createArgumentParser() { ArgumentParser parser = ArgumentParsers.newFor("FetchReportResultRows") .build() .defaultHelp(true) .description("Fetches rows for a completed report result."); // Required arguments. parser .addArgument("-a", "--account_id") .help("The account ID of the curator.") .required(true) .type(Long.class); parser .addArgument("-r", "--report_id") .help("The resource ID of the report.") .required(true); parser .addArgument("--result_id") .help("The resource ID of the report result. This is identical to the resource ID of " + "the corresponding report run operation.") .required(true); // Optional arguments. parser .addArgument("--page_size") .help("The maximum number of rows to return per page.") .type(Integer.class); parser .addArgument("--page_token") .help("A page token, received from a previous `FetchReportResultRows` call."); return parser; } public static void main(String[] args) { ArgumentParser parser = createArgumentParser(); Namespace parsedArgs = null; try { parsedArgs = parser.parseArgs(args); } catch (ArgumentParserException ex) { parser.handleError(ex); System.exit(1); } CurationPartners client = null; try { client = Utils.getCurationPartnersClient(); } catch (IOException ex) { System.out.printf("Unable to create Curation Partners API service:%n%s", ex); System.out.println("Did you specify a valid path to a service account key file?"); System.exit(1); } catch (GeneralSecurityException ex) { System.out.printf("Unable to establish secure HttpTransport:%n%s", ex); System.exit(1); } try { execute( client, parsedArgs.getLong("account_id"), parsedArgs.getString("report_id"), parsedArgs.getString("result_id"), parsedArgs.getInt("page_size"), parsedArgs.getString("page_token")); } catch (IOException ex) { System.out.printf("Curation Partners API returned error response:%n%s", ex); System.exit(1); } } }
Możesz określić te parametry zapytania:
pageSize: maksymalna liczba wierszy do zwrócenia. Domyślna wartość to 1000 wierszy, a maksymalna – 10 000 wierszy.pageToken: token strony zwrócony w poprzedniej odpowiedzifetchRows, aby pobrać następną partię wierszy.
Odpowiedź zawiera te pola:
rows: tablica obiektówRow. Każdy wiersz zawiera:dimensionValues: wartości każdego żądanego wymiaru w tej samej kolejności co wymiary w definicji raportu.metricValueGroups: grupy wartości danych odpowiadające zakresom dat. Każda grupa zawiera listęprimaryValuesw tej samej kolejności co dane w definicji raportu.
dateRanges: obliczone stałe zakresy dat dla raportu. PoledateRangesjest uwzględniane tylko w treści odpowiedzi na pierwszej stronie.totalRowCount: łączna liczba wierszy w wyniku raportu. PoletotalRowCountjest uwzględniane tylko w treści odpowiedzi na pierwszej stronie.nextPageToken: token, który należy przekazać w kolejnych żądaniach, aby pobrać następną stronę wierszy. Jeśli nie ma dodatkowych wierszy, Curation Partners API pomija to pole w treści odpowiedzi.
W przykładzie REST curators.reports.results.fetchRows każdy element w rows jest bezpośrednio powiązany z elementem ReportDefinition skonfigurowanym w raporcie:
dimensionValues: zawiera wartości odpowiadające każdemu wymiarowi w polureportDefinition.dimensionsw dokładnie takiej kolejności, w jakiej zostały określone. W tym przykładzie pierwsza wartość2026-08-01odpowiada wymiarowiDATE, a druga wartośćsegment-1001odpowiada wymiarowiCURATION_DATA_SEGMENT_ID.metricValueGroups: zawiera wartości danych pogrupowane w zakresach dat raportu. W każdej grupie poleprimaryValueszawiera wartości odpowiadające każdemu danemu w polureportDefinition.metricsw dokładnie takiej kolejności, w jakiej zostały określone. W tym przykładzie 4 wartości odpowiadają tym wartościom wyliczeniaMetric:IMPRESSIONS:150000CLICKS:3200SPEND:450.75CURATION_PARTNER_FEE:45.08
dateRanges: zawiera stały zakres dat obliczony przez Google dla zakresu względnegoTHIS_MONTH_TO_DATEskonfigurowanego w definicji raportu.
Dalsze kroki
- Dowiedz się, jak tworzyć i modyfikować raporty za pomocą Curation Partners API.
- Dowiedz się, jak wyświetlać istniejące raporty za pomocą Curation Partners API.
- Dowiedz się, jak uruchamiać raporty za pomocą Curation Partners API.